var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React, { useEffect } from 'react';
var ChartSub = function (_a) {
    var _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t;
    var setup = _a.setup, subChartData = _a.subChartData;
    var _u = React.useState(null), subData = _u[0], setSubData = _u[1];
    var getValueClass = function (value) {
        var stringValue = String(value);
        if (stringValue.startsWith('-'))
            return 'decrease';
        if (stringValue.startsWith('+'))
            return 'increase';
        return '';
    };
    var baseStyles = ((_c = (_b = setup.sub) === null || _b === void 0 ? void 0 : _b.styles) === null || _c === void 0 ? void 0 : _c.all)
        ? {
            fontSize: setup.sub.styles.all.font_size || undefined,
            color: setup.sub.styles.all.color || undefined,
            backgroundColor: setup.sub.styles.all.background_color || undefined,
            border: setup.sub.styles.all.border || undefined,
            borderRadius: setup.sub.styles.all.border_radius || undefined,
        }
        : {};
    var leftStyles = __assign(__assign(__assign({}, baseStyles), (((_e = (_d = setup.sub) === null || _d === void 0 ? void 0 : _d.styles) === null || _e === void 0 ? void 0 : _e.left)
        ? {
            fontSize: setup.sub.styles.left.font_size || undefined,
            color: setup.sub.styles.left.color || undefined,
            backgroundColor: setup.sub.styles.left.background_color || undefined,
            border: setup.sub.styles.left.border || undefined,
            borderRadius: setup.sub.styles.left.border_radius || undefined,
        }
        : {})), { display: ((_f = setup.sub) === null || _f === void 0 ? void 0 : _f.inline) ? 'flex' : 'block', width: '33.333%', justifyContent: 'left' });
    var centerStyles = __assign(__assign(__assign({}, baseStyles), (((_h = (_g = setup.sub) === null || _g === void 0 ? void 0 : _g.styles) === null || _h === void 0 ? void 0 : _h.center)
        ? {
            fontSize: setup.sub.styles.center.font_size || undefined,
            color: setup.sub.styles.center.color || undefined,
            backgroundColor: setup.sub.styles.center.background_color || undefined,
            border: setup.sub.styles.center.border || undefined,
            borderRadius: setup.sub.styles.center.border_radius || undefined,
        }
        : {})), { display: ((_j = setup.sub) === null || _j === void 0 ? void 0 : _j.inline) ? 'flex' : 'block', width: '33.333%', justifyContent: 'center' });
    var rightStyles = __assign(__assign(__assign({}, baseStyles), (((_l = (_k = setup.sub) === null || _k === void 0 ? void 0 : _k.styles) === null || _l === void 0 ? void 0 : _l.right)
        ? {
            fontSize: setup.sub.styles.right.font_size || undefined,
            color: setup.sub.styles.right.color || undefined,
            backgroundColor: setup.sub.styles.right.background_color || undefined,
            border: setup.sub.styles.right.border || undefined,
            borderRadius: setup.sub.styles.right.border_radius || undefined,
        }
        : {})), { display: ((_m = setup.sub) === null || _m === void 0 ? void 0 : _m.inline) ? 'flex' : 'block', width: '33.333%', justifyContent: 'right' });
    var globalCssClass = ((_q = (_p = (_o = setup.sub) === null || _o === void 0 ? void 0 : _o.styles) === null || _p === void 0 ? void 0 : _p.all) === null || _q === void 0 ? void 0 : _q.css_class) || '';
    useEffect(function () {
        if (subChartData && Array.isArray(subChartData) && subChartData.length > 0) {
            setSubData(subChartData[0]);
        }
    }, [subChartData]);
    if (!subData)
        return null;
    return (_jsxs("div", { className: "s-dashboard-sub", style: {
            display: 'flex',
            alignItems: 'center',
            justifyContent: 'space-between',
            width: '100%',
        }, children: [((_r = setup.sub) === null || _r === void 0 ? void 0 : _r.left) && (_jsxs("div", { className: "s-dashboard-sub__left ".concat(globalCssClass), style: leftStyles, children: [setup.sub.left.label && _jsx("div", { className: "s-dashboard-sub__left--label", children: setup.sub.left.label }), _jsx("div", { className: "s-dashboard-sub__left--value", children: subData[setup.sub.left.field || 'left'] })] })), ((_s = setup.sub) === null || _s === void 0 ? void 0 : _s.center) && (_jsxs("div", { className: "s-dashboard-sub__center ".concat(globalCssClass), style: centerStyles, children: [setup.sub.center.label && _jsx("div", { className: "s-dashboard-sub__center--label", children: setup.sub.center.label }), _jsx("div", { className: "s-dashboard-sub__center--value", children: subData[setup.sub.center.field || 'center'] })] })), ((_t = setup.sub) === null || _t === void 0 ? void 0 : _t.right) && (_jsxs("div", { className: "s-dashboard-sub__right ".concat(globalCssClass), style: rightStyles, children: [setup.sub.right.label && _jsx("div", { className: "s-dashboard-sub__right--label", children: setup.sub.right.label }), _jsx("div", { className: "s-dashboard-sub__right--value ".concat(getValueClass(subData[setup.sub.right.field || 'right'])), children: subData[setup.sub.right.field || 'right'] })] }))] }));
};
export default ChartSub;
